/*
 * Newt-Puzzle
 * Copyright (C) Aude Jaulent 2008, 2009 <elderme@tuxfamily.org>
 * 
 * Newt-Puzzle is free software: you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published by the
 * Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * Newt-Puzzle is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License along
 * with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef _DISPLAY2D_H_
#define _DISPLAY2D_H_

#include "glUtil.h"
#include "entity2d.h"

 
class Display2D
{
public:
	Display2D();
		
	void setOrthoParameters(double _left,double _right, double _bottom, double _top);
	void setViewPortParameters(int _xWindow, int _yWindow, int _width, int _height); 		
		
	void addEntity2D(Entity2D *entity);	
	
	void initViewport();

	bool isInViewport(int x, int y);		
	int getHit(int bufSize, int xMouse, int yMouse, float delX, float delY);
	void renderClickableObjects();		

	void render();
		
		
			
private:
	/* 4 parameters for GluOrtho2D */
	double left;
	double right;
	double bottom;
	double top;
	/* 4 parameters for glViewport */
	int xWindow;
	int yWindow;
	int width;
	int height;
		
	std::vector<Entity2D*> entity2DList;
};

#endif // _DISPLAY2D_H_
