/*
 * Newt-Puzzle
 * Copyright (C) Aude Jaulent 2008, 2009 <elderme@tuxfamily.org>
 * 
 * Newt-Puzzle is free software: you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published by the
 * Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * Newt-Puzzle is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License along
 * with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include "entity2d.h"

Entity2D::Entity2D(Material *material, bool visible) :
	mpMaterial(material), mVisible(visible) {
}

Entity2D::Entity2D(Material *material, bool visible, int numClick) :
	mpMaterial(material), mVisible(visible), mNumClick(numClick) {
}
	
Entity2D::~Entity2D() {

}


int Entity2D::getNumClick() {
	return mNumClick;
}

void Entity2D::setNumClick(int numClick) {
	mNumClick = numClick;
}

void Entity2D::setVisibility(bool visible) {
	mVisible = visible;
}

Material* Entity2D::getMaterial(void) {
	return mpMaterial;	
}
void Entity2D::setMaterial(Material* material) {
	mpMaterial = material;
}

void Entity2D::render() {
	mpMaterial->activate(0, FIXED_PIPELINE);
	drawGeometry();
	mpMaterial->release();
}


