/*
 * Newt-Puzzle
 * Copyright (C) Aude Jaulent 2008, 2009 <elderme@tuxfamily.org>
 * 
 * Newt-Puzzle is free software: you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published by the
 * Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * Newt-Puzzle is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License along
 * with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef _IMAGEPNG_H_
#define _IMAGEPNG_H_

#include "glUtil.h"
#include "textUtil.h"
#include "color.h"

#include <png.h>

 
using namespace std;
 
 
class ImagePng
{
public:
	ImagePng(string filename, int color);
	ImagePng(int width, int height, GLenum format, GLubyte* texels);
	ImagePng(wstring text, int color, int width, int height);
	ImagePng(wstring text, int textColor, float textCoeff, int backgroundColor, float backgroundCoeff, int width, int height);
		
	~ImagePng();

	void setFormat(int colorType);
	void setFormatBis(GLenum format);
	void setTexels(GLubyte* texels);
			
	GLuint getWidth();
	GLuint getHeight();
	GLenum getFormat();
	int getInternalFormat();
	int getPngFormat();
	GLuint getId();
	GLubyte* getTexels();
	
	//very slow. Prefer use a textured rectangle.
	void raster2D(int wPosition, int hPosition);
	
	bool writeToFile(string filename);
	
protected:
	GLuint mWidth;
	GLuint mHeight;
	GLenum mFormat;	/* RVB, RVBA, Luminance, Luminance Alpha */
	GLint internalFormat;
	GLubyte *mTexels; 	

};


#endif // _IMAGEPNG_H_
