/*
 * Newt-Puzzle
 * Copyright (C) Aude Jaulent 2009 <elderme@tuxfamily.org>
 * 
 * Newt-Puzzle is free software: you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published by the
 * Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * Newt-Puzzle is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License along
 * with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef _WATERPLANE_H_
#define _WATERPLANE_H_

#include "glUtil.h"
#include "color.h"
#include "mesh.h"
#include "../variousEntities/rectangle.h"

class WaterPlane
{
public:
	WaterPlane(Color color, float height, Mesh *waterSurface, Vector3 center);
	WaterPlane(Color color, float height, float farClip);
	~WaterPlane();

	Color getColor();
	float getHeight ();
		
	void drawSurface();		
		
protected:
	Color mColor;
	float mHeight;
		
	Mesh *mpWaterSurface;
	Vector3 mCenter;
		
	bool infinite;
	float mFarClip;
};







#endif // _WATERPLANE_H_
